function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : String(i); }
function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import React, { useImperativeHandle, forwardRef } from "react";
import classNames from "classnames";
import { getUniqueId } from "@pisell/utils";
var ListComponent = function ListComponent(_ref, ref) {
  var _ref$value = _ref.value,
    value = _ref$value === void 0 ? [] : _ref$value,
    _ref$onChange = _ref.onChange,
    onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange,
    _ref$renderItem = _ref.renderItem,
    renderItem = _ref$renderItem === void 0 ? function () {
      return null;
    } : _ref$renderItem,
    _ref$renderAddButton = _ref.renderAddButton,
    renderAddButton = _ref$renderAddButton === void 0 ? function () {
      return null;
    } : _ref$renderAddButton,
    _ref$createItem = _ref.createItem,
    createItem = _ref$createItem === void 0 ? function (item) {
      return item;
    } : _ref$createItem,
    _ref$maxLength = _ref.maxLength,
    maxLength = _ref$maxLength === void 0 ? 999 : _ref$maxLength,
    _ref$rowKey = _ref.rowKey,
    rowKey = _ref$rowKey === void 0 ? "_id" : _ref$rowKey,
    className = _ref.className,
    style = _ref.style,
    wrapClassName = _ref.wrapClassName;
  var handleAddItem = function handleAddItem(item) {
    if (value.length < maxLength) {
      // 添加新项的逻辑
      onChange([].concat(_toConsumableArray(value), [createItem(_objectSpread(_defineProperty({}, rowKey, getUniqueId()), item))]));
    }
  };
  var handleOnChangeItem = function handleOnChangeItem(item, newValue) {
    onChange(value.map(function (d) {
      if (d[rowKey] === item[rowKey]) {
        return _objectSpread(_objectSpread({}, d), newValue);
      }
      return d;
    }));
  };
  var handleDeleteItem = function handleDeleteItem(current) {
    // 删除选定项的逻辑
    onChange(value.filter(function (item) {
      return item[rowKey] !== current[rowKey];
    }));
  };
  useImperativeHandle(ref, function () {
    return {
      add: handleAddItem,
      delete: handleDeleteItem
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: classNames("list-component-wrap", wrapClassName)
  }, /*#__PURE__*/React.createElement("ul", {
    className: classNames("list-component-ul", className),
    style: style
  }, value.map(function (item, index) {
    return renderItem(item, index, handleDeleteItem, handleOnChangeItem);
  })), value.length < maxLength && renderAddButton(handleAddItem));
};
export default /*#__PURE__*/forwardRef(ListComponent);